#ifndef _LIST_H_
#define _LIST_H_

typedef struct {
  int *data;
  int size;
  int maxsize;
  char *buf;
  int buf_size;
  int buf_maxsize;
  int width;
} list;

int list_add(list *, char *);
int list_add_hidden_int(list *, int);
int list_add_dir(list *, char *);
int list_size(list *);
char *list_get(list *, int);
void empty_list(list *);

void list_sort(list *);

#endif /* _LIST_H_ */
