/*
 * act as a pipo server
 * wait a client
 * you type something and this is sent to the client (ah, no, not for
 * the windows version, sorry)
 * you see what the client sends
 */

/* gcc pipo_server_windows.c -lws2_32 */

#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
//#include <sys/socket.h>
//#include <netinet/in.h>
#include <stdio.h>
//#include <netdb.h>
#include <stdlib.h>
#include <unistd.h>

#include <winsock2.h>

int main(int nb, char **v)
{
    WSADATA wsaData;

    int iResult;
    iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
    if (iResult != 0) {
        printf("WSAStartup failed: %d\n", iResult);
        return 1;
    }
        char buf[4096];
        struct sockaddr_in addr;
        int fd=socket(PF_INET, SOCK_STREAM, IPPROTO_TCP), fd2;
        int size=sizeof(struct sockaddr_in);

        if (fd==-1) {
                perror("socket");
                return 1;
        }

	//{int adlen=1; setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &adlen, sizeof(int));}

        if (nb!=2) {
                fprintf(stderr, "usage : %s <input port>\n", v[0]);
                return 1;
        }

        addr.sin_family=AF_INET;
        addr.sin_addr.s_addr=INADDR_ANY;
        addr.sin_port=htons(atoi(v[1]));

        if (bind(fd, (struct sockaddr *)&addr, sizeof(struct sockaddr_in))==-1) {
                perror("bind");
                return 1;
        }

        listen(fd, 5);
        fd2=fd;
        if ((fd=accept(fd, (struct sockaddr *)&addr, &size))==-1) {
                perror("accept");
                return 1;
        }
	close(fd2);
	fprintf(stderr, "connection coming in, let's connect to the other side\n");

        while(1) {
	  fd_set rd;
	  fd_set ex;

	  FD_ZERO(&rd);
	  FD_SET(fd, &rd);
	  //FD_SET(0, &rd);
	  if (select(100, &rd, 0, &ex, 0) == -1) {
	    perror("select");
	    goto fin;
	  }
	  fprintf(stderr, "select done\n");
	  if (FD_ISSET(fd, &rd)) {
	    int nb;
	    fprintf(stderr, "we have something to read\n");
	    //nb = read(fd, &buf, 4096);
	    nb = recv(fd, buf, 4096, 0);
	    fprintf(stderr, "it's read...\n");
	    if (nb <= 0) {
	      perror("read");
	      goto fin;
	      return 1;
	    }
	    if (write(1, &buf, nb) != nb) {
	      perror("write");
	      goto fin;
	    }
	  }
	  if (FD_ISSET(0, &rd)) {
	    int nb = read(0, &buf, 4094);
	    if (nb <= 0) {
	      perror("read");
	      goto fin;
	    }
	    buf[nb] = 0;
	    if (!strcmp(buf, "quit\n")) goto fin;
	    buf[nb-1] = 13; buf[nb] = 10; buf[nb+1] = 0; nb++;
	    if (write(fd, &buf, nb) != nb) {
	      perror("write");
	      goto fin;
	    }
	  }
        }

fin:
        close(fd);
        return 0;
}
