<?php

include_once "iv.php";
include_once "key.php";

/* convert the key from hex to string */
function get_key()
{
  global $key;
  /* force key_array to be a string */
  $key_array = chr(0);
  $key_array[256/8-1] = chr(0);
  /* feed it */
  for ($i = 0; $i < 256/8; $i++)
    $key_array[$i] = chr(hexdec($key[$i*2] . $key[$i*2+1]));
  return $key_array;
}

/* convert the iv from hex to string */
function get_iv()
{
  global $iv;
  /* force iv_array to be a string */
  $iv_array = chr(0);
  $iv_array[7+8] = chr(0);
  for ($i = 0; $i < 8+8; $i++)
//    $iv_array[$i] = chr(hexdec($iv[(7+8-$i)*2] . $iv[(7+8-$i)*2+1]));
    $iv_array[$i] = chr(hexdec($iv[$i*2] . $iv[$i*2+1]));
  return $iv_array;
}

function save_iv($iv)
{
  $iv_string = "";
  $f = fopen("iv.php", "wb");
//  for ($i = 7+8; $i >= 0; $i--) {
  for ($i = 0; $i < 8+8; $i++) {
    $iv_string .= dechex((ord($iv[$i])>>4) & 0xf);
    $iv_string .= dechex(ord($iv[$i]) & 0xf);
  }
  fwrite($f, "<?php \$iv = \"" .$iv_string . "\"; ?>\n");
  fclose($f);
}

/* return -1 if a<b, 1 if a>b, 0 if a=b */
function compare_iv($a, $b)
{
  $order = array(
    /* 7 is bigger */
    1 * 4 + 3, 1 * 4 + 2, 1 * 4 + 1, 1 * 4 + 0,
    /* then 6 */
    0 * 4 + 3, 0 * 4 + 2, 0 * 4 + 1, 0 * 4 + 0,
    /* then 9 */
    3 * 4 + 3, 3 * 4 + 2, 3 * 4 + 1, 3 * 4 + 0,
    /* finally 8 */
    2 * 4 + 3, 2 * 4 + 2, 2 * 4 + 1, 2 * 4 + 0);
  for ($i = 0; $i < 16; $i++) {
    if ($a[$order[$i]] < $b[$order[$i]]) return -1;
    if ($a[$order[$i]] > $b[$order[$i]]) return 1;
  }
  return 0;
}

?>
