<?php

/* return the position of the end of string */
function get_string($input, $pos, &$out)
{
  /* we have a length first */
  $input_len = strlen($input);
  $length = 0;
  while (1) {
    if ($pos == $input_len) reply_error("Bad string.");
    if (ord($input[$pos]) == ord(' ')) break;
    if (!(ord($input[$pos]) >= ord('0') &&
          ord($input[$pos]) <= ord('9'))) reply_error("Bad string.");
    $length *= 10;
    $length += ord($input[$pos]) - ord('0');
    $pos++;
  }
  $pos++;
  if ($length <= 0) reply_error("Bad string.");
  if ($length + $pos > $input_len) reply_error("Bad string.");
  for ($i = 0; $i < $length; $i++, $pos++)
    $out[$i] = $input[$pos];
  return $pos;
}

/* return the position of the end of int */
function get_int($input, $pos, &$out)
{
  $input_len = strlen($input);
  $val = 0;
  while (1) {
    if ($pos == $input_len) reply_error("Bad integer.");
    if (ord($input[$pos]) == ord(' ')) break;
    if (!(ord($input[$pos]) >= ord('0') &&
          ord($input[$pos]) <= ord('9'))) reply_error("Bad integer.");
    $val *= 10;
    $val += ord($input[$pos]) - ord('0');
    $pos++;
  }
  $out = $val;
  $pos++;
  return $pos;
}

function get_buffer($input, $pos, $len, &$out)
{
  for ($i = $pos, $j = 0; $i < $pos + $len; $i++, $j++) $out[$j] = $input[$i];
  return $pos + $len;
}

?>
