<?php

include_once "key.php";
include_once "iv.php";
include_once "salsa20-7.php";
include_once "nonce.php";

function decrypt_input($in, $in_size)
{
  /* force out to be a string and alloc it all */
  $out = chr(0);
  $out[$in_size-1] = chr(0);
  ECRYPT_encrypt_bytes($in, $out, $in_size);

  return $out;
}

function decrypt_setup()
{
  ECRYPT_keysetup(get_key());
  ECRYPT_ivsetup(get_iv());
}

function decrypt_save()
{
  $iv = salsa20_get_iv();
  save_iv($iv);
}

?>
